/*
 * ASE1708.asm
 *
 * Created: 23/11/2017 9.19.01
 * Author: Roberto Roncella
 * Realizzare un sottoprogramma per il microcontrollore AVR XMEGA256A3BU, 
 * in grado di valutare l'area di un cerchio di raggio r.
 * Il valore di r  espresso su 1 byte (intero assoluto) contenuto in R16, 
 * mentre per ? si ritiene accettabile un valore frazionale [2.6].
 * Per il risultato, di cui vogliamo la parte intera, si usi un numero adeguato di byte 
 * (che deve essere valutato), e si lasci nei registri a partire da R18.
 *
 * Note: per ? si usera` il valore 64? = 201 (in binario 11.001001) 
 * da interpretare come [2.6]. Il risultato massimo si ha per r = 255 
 * ed e` rappresentabile su 3 byte (R20:R19:R18). Il risultato sara` affetto da errore
 * a causa della rappresentazione approssimata di ?. Tale errore e` massimo per
 * r = 255 e vale 63.
 */ 
 ldi R16,0x00
 ldi YL,0x00
 ldi YH,0x20
 clr R21
 main:
   rcall circle
   inc R16
   st Y,R18
   std Y+1,R19
   std Y+2,R20
   std Y+3,R21
   rjmp main

 circle:
 push R0 //salva registri
 push R1
 push R17
 ldi R20,201 //? in [2.6]
 mul R16,R20
 movw R19:R18,R1:R0 //salva ?r
 mul R16,R18 //esegue r*low(?r)
 mov R17,R0 //salva low(r*low(?r))
 mov R18,R1 //salva high(r*low(?r))
 mul R16,R19 //esegue r*high(?r)
 clr R19
 clr R20
 add R18,R0
 adc R19,R1 //in R19:R18:R17 c'e` r*?r come [18.6]
 lsl R17 // riporta la parte intera in R20:R19:R18
 rol R18
 rol R19
 rol R20
 lsl R17
 rol R18
 rol R19
 rol R20
 pop R17 //ripristina registri
 pop R1
 pop R0
 ret